Module java.base
Package java.util.stream

# Enum Class Collector.Characteristics

java.lang.Object
java.lang.Enum<Collector.Characteristics>
java.util.stream.Collector.Characteristics

All Implemented Interfaces:
  `Serializable`, `Comparable<Collector.Characteristics>`, `Constable`

Enclosing interface:
  `Collector<T,A,R>`

public static enum Collector.Characteristics extends Enum<Collector.Characteristics>
Characteristics indicating properties of a `Collector`, which can be used to optimize reduction implementations.

## Nested Class Summary

## Nested classes/interfaces declared in class java.lang.Enum

`Enum.EnumDesc<E extends Enum<E>>`

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`CONCURRENT`
Indicates that this collector is concurrent, meaning that the result container can support the accumulator function being called concurrently with the same result container from multiple threads.
`IDENTITY_FINISH`
Indicates that the finisher function is the identity function and can be elided.
`UNORDERED`
Indicates that the collection operation does not commit to preserving the encounter order of input elements.

## Method Summary

Modifier and Type
Method
Description
`static Collector.Characteristics`
`valueOf(String name)`
Returns the enum constant of this class with the specified name.
`static Collector.Characteristics[]`
`values()`
Returns an array containing the constants of this enum class, in the order they are declared.

### Methods declared in class java.lang.Enum

`clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods declared in class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### CONCURRENT

public static final Collector.Characteristics CONCURRENT
Indicates that this collector is concurrent, meaning that the result container can support the accumulator function being called concurrently with the same result container from multiple threads.

If a `CONCURRENT` collector is not also `UNORDERED`, then it should only be evaluated concurrently if applied to an unordered data source.

### UNORDERED

public static final Collector.Characteristics UNORDERED
Indicates that the collection operation does not commit to preserving the encounter order of input elements. (This might be true if the result container has no intrinsic order, such as a `Set`.)

### IDENTITY_FINISH

public static final Collector.Characteristics IDENTITY_FINISH
Indicates that the finisher function is the identity function and can be elided. If set, it must be the case that an unchecked cast from A to R will succeed.

## Method Details

### values

public static Collector.Characteristics[] values()
Returns an array containing the constants of this enum class, in the order they are declared.

Returns:
  an array containing the constants of this enum class, in the order they are declared

### valueOf

public static Collector.Characteristics valueOf(String name)
Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum class has no constant with the specified name
  `NullPointerException` - if the argument is null